function paper_plot_gold_ball()
    dir = '.';

    pic = 3;
    
    if(pic == 1)
        str = 'goldballs';
    elseif(pic == 2)
        str = 'flowersdouble';
    elseif(pic == 3)
        str = 'galaxy';
    end
    load([str '.mat']);
    x0 = x0 / norm(x0);
    
    set(0,'defaultaxesfontsize',15, ...
       'defaultaxeslinewidth',0.7, ...
       'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
    set(0,'defaultlinemarkersize',10)

    x1 = abs(x0);
    if(pic == 1)
        nv = 64 / max(x1(:));
    elseif(pic == 2)
        nv = 256 / max(x1(:));
    elseif(pic == 3)
        nv = 256 / max(x1(:));
    end
    hf1 = figure(1);clf
%     set(gcf,'Position',[100,100,780,300]);
%     subplot(1, 2, 1);
    
    if(pic == 1)
        image(x1 * nv);
        colormap jet
    elseif(pic == 2)
        imshow(uint8(x1 * nv));
    elseif(pic == 3)
        imshow(uint8(x1 * nv));
    end
    
    if(pic == 1)
        h = colorbar('YTick', [1, 64], 'YTickLabel', {'min', 'max'});
        set(h, 'ylim', [1 64])
        title('Gold balls data set');
    elseif(pic == 2)
        h = colorbar('YTick', [1, 256], 'YTickLabel', {'min', 'max'});
        set(h, 'ylim', [1 256])
        title('Keukenhof park');
    elseif(pic == 3)
        h = colorbar('YTick', [1, 256], 'YTickLabel', {'min', 'max'});
        set(h, 'ylim', [1 256])
        title('Galaxy');
    end
    axis off
    hf1 = figure(1);
    savefig(hf1, [pwd '/' str '.fig']);
    
    amplification = 1;
    ls = [18];
    taus = [Inf];
    for i = 1 : length(taus)
        load([dir '/' str '_LRBFGS_' num2str(taus(i)) '_0_' num2str(ls(1)) '.mat']);
        aaa = load([dir '/' str '_LRBFGS_' num2str(taus(i)) '_0_' num2str(ls(1)) '.mat']);
        ssnr = aaa.snr;
        x0 = x0 / norm(x0);
        LRBFGSend = recover_x(LRBFGSend, x0);
        hf2 = figure(2);%clf
%         set(gcf,'Position',[100,100,780,300]);
%         subplot(1, 2, 1);
%         image(abs(LRBFGSend) * nv);
%         title([num2str(ls(1)) ' Gaussian masks, SNR: ' num2str(taus(i))]);
%         axis off
%         subplot(1, 2, 2);

        if(pic == 1)
            image((abs(x0 - LRBFGSend)) * nv * amplification);
            colormap jet
        elseif(pic == 2)
            imshow(uint8((abs(x0 - LRBFGSend)) * nv * amplification));
        end
%         title([num2str(amplification) ' times error']);
        title(['error']);
        axis off
        savefig(hf2, [pwd '/' str '_err.fig']);
        fprintf('Gaussian SNR:%e, LRBFGSmse:%e, %e dB, time: %f\n', ssnr, LRBFGSmse, 10 * log(LRBFGSmse) / log(10), LRBFGSt);
    end
%     for j = 1 : length(ls)
%         for i = 1 : length(taus)
%             load([dir '/GlodBall_LRBFGS_' num2str(taus(i)) '_1_'  num2str(ls(j)) '.mat']);
%             aaa = load([dir '/GlodBall_LRBFGS_' num2str(taus(i)) '_1_'  num2str(ls(j)) '.mat']);
%             ssnr = aaa.snr;
%             x0 = x0 / norm(x0);
%             LRBFGSend = recover_x(LRBFGSend, x0);
%             figure(i+1+length(taus) * j);clf
%             set(gcf,'Position',[100,100,780,300]);
%             subplot(1, 2, 1);
%             image(abs(LRBFGSend) * nv);
%             title([num2str(ls(j)) ' Binary masks, SNR: ' num2str(taus(i))]);
%             axis off
%             subplot(1, 2, 2);
%             image((abs(x0 - LRBFGSend)) * nv * amplification);
%             title([num2str(amplification) ' times error']);
%             axis off
%             fprintf('Binary: SNR:%e, LRBFGSmse:%e, %e dB, time: %f\n', ssnr, LRBFGSmse, 10 * log(LRBFGSmse) / log(10), LRBFGSt);
%         end
%     end
%     
%     for i = 1 : length(taus)
%         load([dir '/GlodBall_LRFISTA_' num2str(taus(i)) '_0_' num2str(ls(1)) '.mat']);
%         aaa = load([dir '/GlodBall_LRFISTA_' num2str(taus(i)) '_0_' num2str(ls(1)) '.mat']);
%         ssnr = aaa.snr;
%         x0 = x0 / norm(x0);
%         LRFISTAend = recover_x(LRFISTAend, x0);
%         figure(i+1 +length(taus)*2);clf
%         set(gcf,'Position',[100,100,780,300]);
%         subplot(1, 2, 1);
%         image(abs(LRFISTAend) * nv);
%         title([num2str(ls(1)) ' Gaussian masks, SNR: ' num2str(taus(i))]);
%         axis off
%         subplot(1, 2, 2);
%         image((abs(x0 - LRFISTAend)) * nv * amplification);
%         title([num2str(amplification) ' times error']);
%         axis off
%         fprintf('Gaussian SNR:%e, LRFISTAmse:%e, %e dB, time: %f\n', ssnr, LRFISTAmse, 10 * log(LRFISTAmse) / log(10), LRFISTAt);
%     end
%     for j = 1 : length(ls)
%         for i = 1 : length(taus)
%             load([dir '/GlodBall_LRFISTA_' num2str(taus(i)) '_1_'  num2str(ls(j)) '.mat']);
%             aaa = load([dir '/GlodBall_LRFISTA_' num2str(taus(i)) '_1_' num2str(ls(1)) '.mat']);
%             ssnr = aaa.snr;
%             x0 = x0 / norm(x0);
%             LRFISTAend = recover_x(LRFISTAend, x0);
%             figure(i+1+length(taus)*3 * j);clf
%             set(gcf,'Position',[100,100,780,300]);
%             subplot(1, 2, 1);
%             image(abs(LRFISTAend) * nv);
%             title([num2str(ls(j)) ' Binary masks, SNR: ' num2str(taus(i))]);
%             axis off
%             subplot(1, 2, 2);
%             image((abs(x0 - LRFISTAend)) * nv * amplification);
%             title([num2str(amplification) ' times error']);
%             axis off
%             fprintf('Gaussian SNR:%e, LRFISTAmse:%e, %e dB, time: %f\n', ssnr, LRFISTAmse, 10 * log(LRFISTAmse) / log(10), LRFISTAt);
%         end
%     end
end

function output = recover_x(xx, pp)
    x = reshape(xx, [], 1);
    phase = reshape(pp, [], 1);
    X1 = [real(x), imag(x)];
    X2 = [real(phase), imag(phase)];
    [U, S, V] = svd(X2'*X1);
    O = V * U';
%     if(det(O) < 0)
%         O(1, :) = -O(1, :);
%     end
    M = X1 * O;
    output = reshape(complex(M(:, 1), M(:, 2)), size(xx));
end
